﻿using Otter;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Prehistech.Scenes
{
    class WinScreen : Scene
    {
        public Image titleImage = new Image(Assets.WIN_IMAGE);
        public Text enterText = new Text("You had this much health left: " + Global.PlayerHealth, 30);
        public Text enterText2 = new Text("heee!", 30);

        public WinScreen()
        {
            titleImage.ScaleY = 0.80f;
            this.AddGraphic(titleImage);

            enterText.OutlineThickness = 12;
            enterText.CenterOrigin();
            enterText.X = Global.GAME.HalfWidth;
            enterText.Y = 230;
            enterText2.OutlineThickness = 12;
            enterText2.CenterOrigin();
            enterText2.X = Global.GAME.HalfWidth;
            enterText2.Y = 280;
            this.AddGraphic(enterText);
            this.AddGraphic(enterText2);
        }

        public override void Update()
        {
            base.Update();
            if (Global.PlayerSession.Controller.Button("Start").Pressed)
            {
                Global.PlayerX = 0.0f;
                Global.PlayerY = 0.0f;
                Global.PlayerSpeed = 3.0f;
                Global.PlayerHealth = 500;
                Global.PlayerCurrentAnim = "";
                Global.IsPlayerHoldingAssaultRifle = true;
                Global.IsPlayerHoldingBallCannon = false;
                Global.MoiDeaths = 0;
                Global.CatHealth = 1000;
                Global.GAME.RemoveScene();
                Global.GAME.AddScene(new TempleMainRoom());
            }
        }
    }
}
