﻿using Otter;
using System;
using System.Collections.Generic;

namespace Prehistech.Utility
{
    public class SoundManager
    {
        #region Public Static
        public static Dictionary<string, Sound> sounds = new Dictionary<string, Sound>();
        public static bool isSoundEnabled = true;
        #endregion

        #region Private Variables
        private Sound _levelStarted = new Sound(Assets.SFX_LEVEL_INTRO);
        private Sound _leadBulletShot = new Sound(Assets.SFX_LEAD_BULLET_SHOT);
        private Sound _leadBulletDeath = new Sound(Assets.SFX_LEAD_BULLET_DEATH);
        private Sound _pickUpAssaultRifle = new Sound(Assets.SFX_PICKUP_ASSAULTRIFLE);
        private Sound _dropWeapon = new Sound(Assets.SFX_DROP_WEAPON);
        private Sound _bigRockShot = new Sound(Assets.SFX_BIG_ROCK_SHOT);
        private Sound _bigRockDeath = new Sound(Assets.SFX_BIG_ROCK_DEATH);
        private Sound _ballRolling = new Sound(Assets.SFX_BALLROLLING);
        private Sound _pickUpBallCannon = new Sound(Assets.SFX_PICKUP_BALLCANNON);
        private Sound _enemyStartRoar = new Sound(Assets.SFX_ENEMY_START_ROAR);
        private Sound _moiPowerUp = new Sound(Assets.SFX_MOI_POWER_UP);
        private Sound _catStatuePowerUp = new Sound(Assets.SFX_CAT_STATUE_POWER_UP);
        private Sound _moiDeath = new Sound(Assets.SFX_MOI_DEATH);
        private Sound _playerDeath = new Sound(Assets.SFX_PLAYER_DEATH);
        private Sound _playerHurt = new Sound(Assets.SFX_PLAYER_HURT);
        private Sound _catDeath = new Sound(Assets.SFX_CAT_DEATH);
        #region SoundInstances
        private static Sound locatedSound;
        #region MoiDeath
        private Sound _moiDeath1 = new Sound(Assets.SFX_MOI_DEATH);
        private Sound _moiDeath2 = new Sound(Assets.SFX_MOI_DEATH);
        private Sound _moiDeath3 = new Sound(Assets.SFX_MOI_DEATH);
        private Sound _moiDeath4 = new Sound(Assets.SFX_MOI_DEATH);
        private Sound _moiDeath5 = new Sound(Assets.SFX_MOI_DEATH);
        private Sound _moiDeath6 = new Sound(Assets.SFX_MOI_DEATH);
        private Sound _moiDeath7 = new Sound(Assets.SFX_MOI_DEATH);
        private Sound _moiDeath8 = new Sound(Assets.SFX_MOI_DEATH);
        private Sound _moiDeath9 = new Sound(Assets.SFX_MOI_DEATH);
        private Sound _moiDeath10 = new Sound(Assets.SFX_MOI_DEATH);
        #endregion
        #region moiPowerUp
        private Sound _moiPowerUp1 = new Sound(Assets.SFX_MOI_POWER_UP);
        private Sound _moiPowerUp2 = new Sound(Assets.SFX_MOI_POWER_UP);
        private Sound _moiPowerUp3 = new Sound(Assets.SFX_MOI_POWER_UP);
        private Sound _moiPowerUp4 = new Sound(Assets.SFX_MOI_POWER_UP);
        private Sound _moiPowerUp5 = new Sound(Assets.SFX_MOI_POWER_UP);
        private Sound _moiPowerUp6 = new Sound(Assets.SFX_MOI_POWER_UP);
        private Sound _moiPowerUp7 = new Sound(Assets.SFX_MOI_POWER_UP);
        #endregion
        #region LeadBulletShot
        private Sound _leadBulletShot1 = new Sound(Assets.SFX_LEAD_BULLET_SHOT);
        private Sound _leadBulletShot2 = new Sound(Assets.SFX_LEAD_BULLET_SHOT);
        private Sound _leadBulletShot3 = new Sound(Assets.SFX_LEAD_BULLET_SHOT);
        private Sound _leadBulletShot4 = new Sound(Assets.SFX_LEAD_BULLET_SHOT);
        private Sound _leadBulletShot5 = new Sound(Assets.SFX_LEAD_BULLET_SHOT);
        private Sound _leadBulletShot6 = new Sound(Assets.SFX_LEAD_BULLET_SHOT);
        private Sound _leadBulletShot7 = new Sound(Assets.SFX_LEAD_BULLET_SHOT);
        private Sound _leadBulletShot8 = new Sound(Assets.SFX_LEAD_BULLET_SHOT);
        private Sound _leadBulletShot9 = new Sound(Assets.SFX_LEAD_BULLET_SHOT);
        private Sound _leadBulletShot10 = new Sound(Assets.SFX_LEAD_BULLET_SHOT);
        private Sound _leadBulletShot11 = new Sound(Assets.SFX_LEAD_BULLET_SHOT);
        private Sound _leadBulletShot12 = new Sound(Assets.SFX_LEAD_BULLET_SHOT);
        private Sound _leadBulletShot13 = new Sound(Assets.SFX_LEAD_BULLET_SHOT);
        private Sound _leadBulletShot14 = new Sound(Assets.SFX_LEAD_BULLET_SHOT);
        private Sound _leadBulletShot15 = new Sound(Assets.SFX_LEAD_BULLET_SHOT);
        private Sound _leadBulletShot16 = new Sound(Assets.SFX_LEAD_BULLET_SHOT);
        private Sound _leadBulletShot17 = new Sound(Assets.SFX_LEAD_BULLET_SHOT);
        private Sound _leadBulletShot18 = new Sound(Assets.SFX_LEAD_BULLET_SHOT);
        private Sound _leadBulletShot19 = new Sound(Assets.SFX_LEAD_BULLET_SHOT);
        private Sound _leadBulletShot20 = new Sound(Assets.SFX_LEAD_BULLET_SHOT);
        #endregion
        #region LeadBulletDeath
        private Sound _leadBulletDeath1 = new Sound(Assets.SFX_LEAD_BULLET_DEATH);
        private Sound _leadBulletDeath2 = new Sound(Assets.SFX_LEAD_BULLET_DEATH);
        private Sound _leadBulletDeath3 = new Sound(Assets.SFX_LEAD_BULLET_DEATH);
        private Sound _leadBulletDeath4 = new Sound(Assets.SFX_LEAD_BULLET_DEATH);
        private Sound _leadBulletDeath5 = new Sound(Assets.SFX_LEAD_BULLET_DEATH);
        private Sound _leadBulletDeath6 = new Sound(Assets.SFX_LEAD_BULLET_DEATH);
        private Sound _leadBulletDeath7 = new Sound(Assets.SFX_LEAD_BULLET_DEATH);
        private Sound _leadBulletDeath8 = new Sound(Assets.SFX_LEAD_BULLET_DEATH);
        private Sound _leadBulletDeath9 = new Sound(Assets.SFX_LEAD_BULLET_DEATH);
        private Sound _leadBulletDeath10 = new Sound(Assets.SFX_LEAD_BULLET_DEATH);
        #endregion
        #region BigRockShot
        private Sound _bigRockShot1 = new Sound(Assets.SFX_BIG_ROCK_SHOT);
        private Sound _bigRockShot2 = new Sound(Assets.SFX_BIG_ROCK_SHOT);
        private Sound _bigRockShot3 = new Sound(Assets.SFX_BIG_ROCK_SHOT);
        private Sound _bigRockShot4 = new Sound(Assets.SFX_BIG_ROCK_SHOT);
        private Sound _bigRockShot5 = new Sound(Assets.SFX_BIG_ROCK_SHOT);
        private Sound _bigRockShot6 = new Sound(Assets.SFX_BIG_ROCK_SHOT);
        private Sound _bigRockShot7 = new Sound(Assets.SFX_BIG_ROCK_SHOT);
        private Sound _bigRockShot8 = new Sound(Assets.SFX_BIG_ROCK_SHOT);
        private Sound _bigRockShot9 = new Sound(Assets.SFX_BIG_ROCK_SHOT);
        private Sound _bigRockShot10 = new Sound(Assets.SFX_BIG_ROCK_SHOT);
        #endregion
        #region BigRockDeath
        private Sound _bigRockDeath1 = new Sound(Assets.SFX_BIG_ROCK_DEATH);
        private Sound _bigRockDeath2 = new Sound(Assets.SFX_BIG_ROCK_DEATH);
        private Sound _bigRockDeath3 = new Sound(Assets.SFX_BIG_ROCK_DEATH);
        private Sound _bigRockDeath4 = new Sound(Assets.SFX_BIG_ROCK_DEATH);
        private Sound _bigRockDeath5 = new Sound(Assets.SFX_BIG_ROCK_DEATH);
        private Sound _bigRockDeath6 = new Sound(Assets.SFX_BIG_ROCK_DEATH);
        private Sound _bigRockDeath7 = new Sound(Assets.SFX_BIG_ROCK_DEATH);
        private Sound _bigRockDeath8 = new Sound(Assets.SFX_BIG_ROCK_DEATH);
        private Sound _bigRockDeath9 = new Sound(Assets.SFX_BIG_ROCK_DEATH);
        private Sound _bigRockDeath10 = new Sound(Assets.SFX_BIG_ROCK_DEATH);
        #endregion
        #endregion
        #endregion

        public SoundManager()
        {
            LoadSounds();
        }
        #region Public Properties
        public bool SoundIsEnabled
        {
            get
            {
                return isSoundEnabled;
            }

            set
            {
                isSoundEnabled = value;
            }
        }
        #endregion

        #region Public Methods and Operators
        public static void PlayRequestedSound(string sound, float volume = 1.0f)
        {
            //get sound.
            //if sound is playing, get the sound again and set it to a new instance,
            //if new sound is playing, get the sound again and set it to a new instance,
            //if new sound is playing, get the sound again and...
            try
            {
                for (var i = 1; i < 20; i++)//max sounds is the biggest number in there
                {
                    sounds.TryGetValue(sound, out locatedSound);
                    if (locatedSound.IsPlaying)
                    {
                        Console.WriteLine("sound " + i + " is playing.");
                        if (i != 1)
                        {
                            if (i.ToString().Length > 1)
                                sound = sound.TrimEnd(sound[sound.Length - 2]);
                            else
                                sound = sound.TrimEnd(sound[sound.Length - 1]);
                        }
                        sound = sound + i.ToString();
                        Console.WriteLine("sound?: " + sound);
                        sounds.TryGetValue(sound, out locatedSound);
                    }
                    else if (isSoundEnabled)
                    {
                        if (i > 5)
                            volume = .5f;
                        locatedSound.Volume = volume;
                        locatedSound.Play();
                        break;
                    }
                }
            }
            catch
            {
                Console.WriteLine("playing the sound Failed");
            }
        }

        public void LoadSounds()
        {
            sounds.Add("_levelStarted", _levelStarted);
            sounds.Add("_pickUpAssaultRifle", _pickUpAssaultRifle);
            sounds.Add("_dropWeapon", _dropWeapon);
            sounds.Add("_ballRolling", _ballRolling);
            sounds.Add("_pickUpBallCannon", _pickUpBallCannon);
            sounds.Add("_enemyStartRoar", _enemyStartRoar);
            sounds.Add("_catStatuePowerUp", _catStatuePowerUp);
            sounds.Add("_playerDeath", _playerDeath);
            sounds.Add("_playerHurt", _playerHurt);
            sounds.Add("_catDeath", _catDeath);
            #region Moi Death
            sounds.Add("_moiDeath", _moiDeath);
            sounds.Add("_moiDeath1", _moiDeath1);
            sounds.Add("_moiDeath2", _moiDeath2);
            sounds.Add("_moiDeath3", _moiDeath3);
            sounds.Add("_moiDeath4", _moiDeath4);
            sounds.Add("_moiDeath5", _moiDeath5);
            sounds.Add("_moiDeath6", _moiDeath6);
            sounds.Add("_moiDeath7", _moiDeath7);
            sounds.Add("_moiDeath8", _moiDeath8);
            sounds.Add("_moiDeath9", _moiDeath9);
            sounds.Add("_moiDeath10", _moiDeath10);
            #endregion
            #region Moi Power up
            sounds.Add("_moiPowerUp", _moiPowerUp);
            sounds.Add("_moiPowerUp1", _moiPowerUp1);
            sounds.Add("_moiPowerUp2", _moiPowerUp2);
            sounds.Add("_moiPowerUp3", _moiPowerUp3);
            sounds.Add("_moiPowerUp4", _moiPowerUp4);
            sounds.Add("_moiPowerUp5", _moiPowerUp5);
            sounds.Add("_moiPowerUp6", _moiPowerUp6);
            sounds.Add("_moiPowerUp7", _moiPowerUp7);
            #endregion
            #region Big Rock Shot
            sounds.Add("_bigRockShot", _bigRockShot);
            sounds.Add("_bigRockShot1", _bigRockShot1);
            sounds.Add("_bigRockShot2", _bigRockShot2);
            sounds.Add("_bigRockShot3", _bigRockShot3);
            sounds.Add("_bigRockShot4", _bigRockShot4);
            sounds.Add("_bigRockShot5", _bigRockShot5);
            sounds.Add("_bigRockShot6", _bigRockShot6);
            sounds.Add("_bigRockShot7", _bigRockShot7);
            sounds.Add("_bigRockShot8", _bigRockShot8);
            sounds.Add("_bigRockShot9", _bigRockShot9);
            sounds.Add("_bigRockShot10", _bigRockShot10);
            #endregion
            #region Big Rock Death
            sounds.Add("_bigRockDeath", _bigRockDeath);
            sounds.Add("_bigRockDeath1", _bigRockDeath1);
            sounds.Add("_bigRockDeath2", _bigRockDeath2);
            sounds.Add("_bigRockDeath3", _bigRockDeath3);
            sounds.Add("_bigRockDeath4", _bigRockDeath4);
            sounds.Add("_bigRockDeath5", _bigRockDeath5);
            sounds.Add("_bigRockDeath6", _bigRockDeath6);
            sounds.Add("_bigRockDeath7", _bigRockDeath7);
            sounds.Add("_bigRockDeath8", _bigRockDeath8);
            sounds.Add("_bigRockDeath9", _bigRockDeath9);
            sounds.Add("_bigRockDeath10", _bigRockDeath10);
            #endregion
            #region Lead Bullet Shot
            sounds.Add("_leadBulletShot", _leadBulletShot);
            sounds.Add("_leadBulletShot1", _leadBulletShot1);
            sounds.Add("_leadBulletShot2", _leadBulletShot2);
            sounds.Add("_leadBulletShot3", _leadBulletShot3);
            sounds.Add("_leadBulletShot4", _leadBulletShot4);
            sounds.Add("_leadBulletShot5", _leadBulletShot5);
            sounds.Add("_leadBulletShot6", _leadBulletShot6);
            sounds.Add("_leadBulletShot7", _leadBulletShot7);
            sounds.Add("_leadBulletShot8", _leadBulletShot8);
            sounds.Add("_leadBulletShot9", _leadBulletShot9);
            sounds.Add("_leadBulletShot10", _leadBulletShot10);
            sounds.Add("_leadBulletShot11", _leadBulletShot11);
            sounds.Add("_leadBulletShot12", _leadBulletShot12);
            sounds.Add("_leadBulletShot13", _leadBulletShot13);
            sounds.Add("_leadBulletShot14", _leadBulletShot14);
            sounds.Add("_leadBulletShot15", _leadBulletShot15);
            sounds.Add("_leadBulletShot16", _leadBulletShot16);
            sounds.Add("_leadBulletShot17", _leadBulletShot17);
            sounds.Add("_leadBulletShot18", _leadBulletShot18);
            sounds.Add("_leadBulletShot19", _leadBulletShot19);
            sounds.Add("_leadBulletShot20", _leadBulletShot20);
            #endregion
            #region Lead Bullet Death
            sounds.Add("_leadBulletDeath", _leadBulletDeath);
            sounds.Add("_leadBulletDeath1", _leadBulletDeath1);
            sounds.Add("_leadBulletDeath2", _leadBulletDeath2);
            sounds.Add("_leadBulletDeath3", _leadBulletDeath3);
            sounds.Add("_leadBulletDeath4", _leadBulletDeath4);
            sounds.Add("_leadBulletDeath5", _leadBulletDeath5);
            sounds.Add("_leadBulletDeath6", _leadBulletDeath6);
            sounds.Add("_leadBulletDeath7", _leadBulletDeath7);
            sounds.Add("_leadBulletDeath8", _leadBulletDeath8);
            sounds.Add("_leadBulletDeath9", _leadBulletDeath9);
            sounds.Add("_leadBulletDeath10", _leadBulletDeath10);
            #endregion
        }

        public void CreateSoundInstances()
        {

        }
        #endregion
    }

}

